import { __awaiter, __decorate } from "tslib";
import { FASTElement, customElement, observable } from '@microsoft/fast-element';
import * as Components from '../components';
import { logger } from '../utils';
import { MainStyles as styles } from './main.styles';
import { InboxTemplate as template } from './main.template';
/**
 * @public
 */
let Inbox = class Inbox extends FASTElement {
    constructor() {
        super(...arguments);
        this.ready = false;
    }
    connectedCallback() {
        const _super = Object.create(null, {
            connectedCallback: { get: () => super.connectedCallback }
        });
        return __awaiter(this, void 0, void 0, function* () {
            _super.connectedCallback.call(this);
            logger.debug(`foundation-inbox is now connected to the DOM`);
            yield this.loadRemotes();
        });
    }
    /**
     * Load remote components
     *
     * @remarks
     *
     * With regards to module federation
     *
     * @internal
     */
    loadRemotes() {
        return __awaiter(this, void 0, void 0, function* () {
            const remoteComponents = yield Components.loadRemotes();
            this.ready = true;
        });
    }
};
__decorate([
    observable
], Inbox.prototype, "ready", void 0);
Inbox = __decorate([
    customElement({
        name: 'foundation-inbox',
        template,
        styles,
    })
], Inbox);
export { Inbox };
